package shared

import (
	"reflect"
	"testing"
)

func TestTagsFromText(t *testing.T) {
	type args struct {
		text string
	}
	tests := []struct {
		name string
		args args
		want []string
	}{
		{
			name: "No tags",
			args: args{"Text with no tags whatsoever"},
			want: []string{},
		}, {
			name: "one tag",
			args: args{"Text with one simple #tag"},
			want: []string{"tag"},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if got := TagsFromText(tt.args.text); !reflect.DeepEqual(got, tt.want) {
				t.Errorf("TagsFromText() = %v, want %v", got, tt.want)
			}
		})
	}
}
