package models

import "database/sql/driver"

type CollectionTargetType string

const (
	CollectionTargetUnknown         = CollectionTargetType("unknown")
	CollectionTargetPinnedNotes     = CollectionTargetType("pinned")
	CollectionTargetReactions       = CollectionTargetType("reactions")
	CollectionTargetBoostsAndQuotes = CollectionTargetType("boosts")
	COllectionTargetFollows         = CollectionTargetType("follows")
	COllectionTargetFollowers       = CollectionTargetType("followers")
)

var AllCollectionTargetTypes = []CollectionTargetType{
	CollectionTargetUnknown,
	CollectionTargetPinnedNotes,
	CollectionTargetReactions,
	CollectionTargetBoostsAndQuotes,
}

func (n *CollectionTargetType) Value() (driver.Value, error) {
	return n, nil
}

func (ct *CollectionTargetType) Scan(value any) error {
	*ct = CollectionTargetType(value.(string))
	return nil
}
