package models

import (
	"gorm.io/gorm"
	"time"
)

// Emotes are combinations of a name, the server it originated from
// and the media for it. Only represents custom emotes, not characters found in unicode
//
// TODO: Include the case of unicode icons being used as emote
type Emote struct {
	ID         string `gorm:"primarykey"`
	CreatedAt  time.Time
	UpdatedAt  time.Time
	DeletedAt  gorm.DeletedAt `gorm:"index"`
	Metadata   MediaMetadata  // The media used by this emote
	MetadataId string         // Id of the media information, primarily for gorm
	// Name of the emote. Also the text for using it in a message (ex. :bob:)
	Name string

	Server   RemoteServer // Server the emote is from
	ServerId uint         // Id of the server
}
