package models

import "regexp"

type FailedOutboundRequestReason string

const (
	RequestFailureNotAttemptedYet   FailedOutboundRequestReason = "not attempted yet"
	RequestFailureUnreachable       FailedOutboundRequestReason = "target not reachable"
	RequestFailureInternalError     FailedOutboundRequestReason = "target internal error"
	RequestFailureRejected          FailedOutboundRequestReason = "request rejected"
	RequestFailureRequestError      FailedOutboundRequestReason = "request returned an error"
	RequestFailureRateLimitedNoInfo FailedOutboundRequestReason = "request was rate-limited, no rate limit info"
	RequestFailureRateLimitTemplate FailedOutboundRequestReason = "request was rate-limited: limit: %d, remaining: %d, reset: %d"
)

var RequestFailureRateLimitRegex = regexp.MustCompile(
	`request was rate-limited: limit: ([0-9\-]+), remaining: ([0-9\-]+), reset: ([0-9\-]+)`,
)
